#include <stdio.h>

// Yes it's possible to swap without the extra variable
// but that's all right.
static void swap(int* a, int* b) {
  int tmp = *a;
  *a = *b;
  *b = tmp;
}

static void quicksort(int* array, int low, int high) {
  if (low >= high) {
    return;
  }
  int mid = low + (high - low) / 2;
  int pivot = array[mid];
  swap(&array[high], &array[mid]);
  int swap_index = low;
  for (int i = low; i < high; ++i) {
    if (array[i] < pivot) {
      swap(&array[i], &array[swap_index]);
      ++swap_index;
    }
  }
  swap(&array[high], &array[swap_index]);
  quicksort(array, low, swap_index - 1);
  quicksort(array, swap_index + 1, high);
}

int main(int argc, char* argv[]) {
  const int array_len = 64;
  int array[array_len];
  printf("Values prior to sorting:");
  for (int i = 0; i < array_len; ++i) {
    array[i] = array_len - i - 1;
    printf(" %d", array[i]);
  }
  printf("\n");
  quicksort(array, 0, array_len - 1);
  printf("Values after sorting:");
  for (int i = 0; i < array_len; ++i) {
    printf(" %d", array[i]);
  }
  printf("\n");

  return 0;
}
